import TransactionService from './transaction.service'

export default {
    list(config) {
        let ta = [
            {"name": "cntl.mgr.list", "old": {"is_own": true}}, // Accounts
            {"name": "cntl.wapi_auth.list", "join": {"0": "api_fkey_cntl_wapi_auth_mgr"}}, // Tokens
            {"name": "cntl.mgr2role.list", "join": {"0": "api_fkey_cntl_wapi_auth_mgr"}}, // Roles
        ]
        return TransactionService.execute(config, ta)
    },
    update(config, {login_name_old, login_name_new, description_new, allow_data_manipulation_new, role_fq_name_list_new}) {
        let ta = [
            {
                "name": "cntl.mgr.update",
                "new": {
                    'login_name': login_name_new,
                    'description': description_new,
                    'allow_data_manipulation': allow_data_manipulation_new,
                },
                "old": {'login_name': login_name_old}
            },
            {
                "name": "cntl.mgr2role.bulk_update",
                "new": {'role_fq_name_list': role_fq_name_list_new, },
                "old": {'mgr_login_name': login_name_new}
            }
        ]
        return TransactionService.execute(config, ta)
    }
}
