import TransactionService from './transaction.service'

export default {
    getOverviewDHCP(config) {
        let ta = [
            {"name": "nd.bcd.list", "old": {"is_own": true, "sorting_params_list": "[\"name\"]"}},
            {"name": "org.unit.list", "join": {"0": "api_fkey_nd_bcd_oe"}},
            {"name": "nd.ip_subnet.list", "join": {"0": "api_fkey_nd_ip_subnet_bcd"}, "old":{"type":4}},
            {"name": "nd.vlan.list", "join": {"0": "api_fkey_nd_vlan_bcd"}},
        ]
        return TransactionService.execute(config, ta);
    },

    getDetailDHCP(config, name) {
        let ta = [
            {"name": "nd.bcd.list", "old": {"name_list": "[\"" + name + "\"]"}},
            {"name": "nd.ip_subnet.list", "join": {"0": "api_fkey_nd_ip_subnet_bcd"}, "old": { "type": 4}},
            {"name": "nd.vlan.list", "join": {"0": "api_fkey_nd_vlan_bcd"}}
        ]
        return TransactionService.execute(config, ta);
    },

    getIPs(config, cidr) {
        let ta = [
            {"name": "dns.ip_addr.list", "old": {"type": 4, "sorting_params_list": ['value'], "value_cidr": cidr, "is_dhcp": true}},
            {"name": "dns.record.list", "old": {"type": "A"} , "join": {"0": "api_fkey_dns_record_target_ipaddr"}}
        ]
        return TransactionService.execute(config, ta);
    },

    getLeases(config, cidr) {
        let ta = [
            {"name": "dhcp.lease.list", "old": {"ip_subnet_cidr": cidr}},
            {"name": "dns.ip_addr.list", "join": {"0": "api_fkey_dhcp_lease_addr"}},
            {"name": "dns.record.list", "join": {"1": "api_fkey_dns_record_target_ipaddr"}}
        ]
        return TransactionService.execute(config, ta);
    }
};

