import {v4 as uuidv4} from "uuid";

export default {
    function2variant(function_name, outline = false) {
        let prefix = outline ? 'outline-' : ''
        switch (function_name) {
            case 'create':
                return prefix + 'success'
            case 'delete':
                return prefix + 'danger'
            case 'update':
            case 'bulk_update':
                return prefix + 'primary'
            default:
                return prefix + 'default'
        }
    },
    function2text(function_name) {
        switch (function_name) {
            case 'create':
                return 'Anlegen'
            case 'delete':
                return 'Löschen'
            case 'update':
            case 'bulk_update':
                return 'Bearbeiten'
            default:
                return function_name
        }
    },
    filter_unchanged_data(d1, d2) {
        return Object.keys(d1).reduce(function (filtered, key) {
            if (!(key in d2) || d1[key] != d2[key]) filtered[key] = d1[key];
            return filtered;
        }, {})
    },
    filter_old_data(params_list, old_data) {
        return Object.keys(old_data).reduce(function (filtered, key) {
            if (key in params_list && 'old' in params_list[key]) filtered[key] = old_data[key];
            return filtered;
        }, {})
    },
    remove_empty_data(params_list, data) {
        return Object.keys(data).reduce(function (filtered, key) {
            if (!(params_list[key].json_data_type == 'number' && data[key] == '')) filtered[key] = data[key];
            return filtered;
        }, {})
    },
    generateDeleteElement(object_fq_name, params_list, old_data, title) {
        let ta = {}
        ta['parameters'] = {
            'new': {}, 'old': Object.keys(old_data).reduce(function (filtered, key) {
                if (params_list.old.includes(key)) filtered[key] = old_data[key];
                return filtered;
            }, {})
        }
        ta['uuid'] = uuidv4()
        ta['object_fq_name'] = object_fq_name
        ta['object_function'] = 'delete'
        ta['object_functions'] = null
        ta['object_title'] = title
        return ta
    }
}
