from flask import render_template, request, redirect
from . import login_api
from net_suite.modules.ldap import ldap
from net_suite.model import *
from net_suite import app

ldap_con = None


@login_api.route('/login', methods=['GET', 'POST'])
def login():
    global ldap_con
    if ldap_con is None:  # lazy initializer.. sorry :(
        ldap_con = ldap.LDAP(ldap_server=app.config.get('LDAP_SERVER'), ldap_bind_user=app.config.get('LDAP_BIND_USER'),
                             ldap_bind_pw=app.config.get('LDAP_BIND_PW'),
                             default_search_base=app.config.get('LDAP_SEARCH_BASE'))
    s = request.environ['beaker.session']
    if 'login' not in s:
        error = None
        error_msg = None
        if request.method == 'POST':
            username = request.form['username'].strip()
            password = request.form['password']
            if ldap_con.login(username=username, password=password):
                user = APIMgr.get_by_login_name(login_name=username, api_cert=app.config.get('WAPI_CERT'),
                                                api_key=app.config.get('WAPI_KEY'))
                if user is not None:
                    s['login'] = user
                    s.save()
                    return redirect('/')
                else:
                    error = True
                    error_msg = "Der KIT-Account ist gültig, jedoch bei keinem DNSVS-Bereich (Subnetz) als Betreuer eingetragen. " \
                                "Bitte wenden Sie sich an das SCC."
            else:
                error = True
                error_msg = 'Benutzername/Passwort fehlerhaft.'
        return render_template('login.html', error=error, error_msg=error_msg,
                               title='Netzdienste-Portal des SCC am KIT')
    return redirect('/')
