from flask import render_template, request, redirect, abort, flash, jsonify
from . import login_db, ldap_con
from net_suite import db
from net_suite.views import get_db_conn
from net_suite.model import *

@login_db.route('/api/login', methods=['GET', 'POST'])
def api_login():
    s = request.environ['beaker.session']
    if 'login' not in s:
        if request.method == 'POST':
            username = request.json['username'].strip()
            password = request.json['password']
            if ldap_con.login(username=username, password=password):
                user = DBMgr.get_by_login_name(db, get_db_conn(), username)
                if user is not None:
                    s['login'] = user
                    s.save()
                    return jsonify({'login': user, 'token': user.create_session_token(db, get_db_conn(), False)})
                else:
                    user = ldap_con.get_simple_kit_user(username=username)
                    s['login'] = user
                    s.save()
                    return jsonify({'login': user})
            else:
                return jsonify({'login': None})
    return jsonify({'login': s['login'], 'token': s['login'].create_session_token(db, get_db_conn(), False)})


@login_db.route('/api/logout', methods=['POST'])
def api_logout():
    s = request.environ['beaker.session']
    if 'login' in s:
        if request.json.get('token_pk', None) is not None:
            APIToken(login_name=s['login'].login_name, pk=int(request.json['token_pk'])).delete(db, get_db_conn())
        s.delete()
    s.save()
    return jsonify({'logout': 'success'})
